#include <errno.h>
#include <fcntl.h>
#include <string.h>
#include <sys/types.h>
#include <time.h>
#include <stdarg.h>
#include <stdio.h>
#define PRTBUFSZ 4096

int dsilogit(char *func, char *msg, ...)
{
	va_list args;
	char prtbuf[PRTBUFSZ];
	int save_errno;
	struct tm *tm;
	time_t current_time;
	FILE *fd_log;
	char *logfile = "/tmp/dsi_rfio.log";

	save_errno = errno;
	va_start (args, msg);
	time (&current_time);
	tm = localtime (&current_time);
	sprintf (prtbuf, "%02d/%02d %02d:%02d:%02d %s: ", tm->tm_mon+1,
		tm->tm_mday, tm->tm_hour, tm->tm_min, tm->tm_sec, func);
	vsprintf (prtbuf+strlen(prtbuf), msg, args);
	va_end (args);
	fd_log = fopen (logfile, "a");
	if (fd_log != NULL) {
		fputs(prtbuf, fd_log);
		fclose (fd_log);
	}
	errno = save_errno;
	return (0);
}
