#include <sys/types.h>
#include <signal.h>
#include <syslog.h>

static sigset_t saved_sigmask;
sigset_t block_sigmask;	
static int delaying;

/* enable_signaling - deliver delayed signals and disable signal delay */
int enable_signaling(void)
{
    if (delaying != 0) {
	delaying = 0;
	if (sigprocmask(SIG_SETMASK, &saved_sigmask, (sigset_t *) 0) < 0) {
	    syslog(LOG_ERR, "sigprocmask: %m");
	    return (-1);
	}
    }
    return (0);
}

/* delay_signaling - save signal mask and block all signals */
int delay_signaling(void)
{
    if (delaying == 0) {
	delaying = 1;
	if (sigprocmask(SIG_BLOCK, &block_sigmask, &saved_sigmask) < 0) {
	    syslog(LOG_ERR, "sigprocmask: %m");
	    return (-1);
	}
    }
    return (0);
}
